Index: extensions/gsdl-video/trunk/perllib/plugins/VideoPlugin.pm
===================================================================
--- extensions/gsdl-video/trunk/perllib/plugins/VideoPlugin.pm	(revision 18543)
+++ extensions/gsdl-video/trunk/perllib/plugins/VideoPlugin.pm	(revision 18556)
@@ -1,5 +1,5 @@
 ######################################################################
 #
-# VideoPlugin.pm -- plugin for processing video largely based on ImagePlug
+# VideoPlugin.pm -- plugin for processing video files 
 # A component of the Greenstone digital library software
 # from the New Zealand Digital Library Project at the 
@@ -24,4 +24,7 @@
 ###########################################################################
 
+# -- Largely modeled on how ImagePlugin works 
+# -- Can convert to audio as well as video
+
 package VideoPlugin;
 
@@ -30,34 +33,13 @@
 no strict 'subs';
 
-use videoconvert;
 use XMLParser;
 use gsprintf;
 
-use BasePlugin;
+use MultimediaPlugin;
+use VideoConverter;
 
 sub BEGIN {
-    @VideoPlugin::ISA = ('BasePlugin');
-
-    if (!defined $ENV{'GEXTVIDEO'}) {
-	print STDERR "Warning: Greenstone Video extension not detected.\n";
-    }
-
-}
-
-
-# Customized from BasePlugin. Make 'incremental' the default 
-# to avoid Greenstone hashing on the file (which in the case of video
-# is HUGE) to generate OID. Also supress 'hash' as option so the user
-# can't choose it.
-
-our $oidtype_list = 
-    [ { 'name' => "auto",
-	'desc' => "{BasePlugin.OIDtype.auto}" },
-      { 'name' => "assigned",
-        'desc' => "{import.OIDtype.assigned}" },
-      { 'name' => "incremental",
-        'desc' => "{import.OIDtype.incremental}" },
-      { 'name' => "dirname",
-        'desc' => "{import.OIDtype.dirname}" } ];
+    @VideoPlugin::ISA = ('MultimediaPlugin', 'VideoConverter');
+}
 
 
@@ -67,109 +49,12 @@
 	'type' => "regexp",
 	'deft' => &get_default_process_exp(),
-	'reqd' => "no" },
-      { 'name' => "OIDtype",
-	'desc' => "{import.OIDtype}",
-	'type' => "enum",
-	'list' => $oidtype_list,
-	'deft' => "incremental",
-	'reqd' => "no",
-	'modegli' => "2" },
-
-      { 'name' => "noscaleup",
-	'desc' => "{VideoPlug.noscaleup}",
-	'type' => "flag",
-	'reqd' => "no" },
-      { 'name' => "use_ascii_only_filenames",
-	'desc' => "{VideoPlug.use_ascii_only_filenames}",
-	'type' => "flag",
-	'reqd' => "no" },
-      { 'name' => "video_excerpt_duration",
-	'desc' => "{VideoPlug.video_excerpt_duration}",
-	'type' => "string",
-	'deft' => "",
-	'reqd' => "no" },
-      { 'name' => "extractthumbnail",
-	'desc' => "{VideoPlug.extractthumbnail}",
-	'type' => "flag",
-	'deft' => "0",
-	'reqd' => "no" },
-      { 'name' => "thumbnailsize",
-	'desc' => "{VideoPlug.thumbnailsize}",
-	'type' => "int",
-	'deft' => "100",
-	'range' => "1,",
-	'reqd' => "no" },
-      { 'name' => "thumbnailtype",
-	'desc' => "{VideoPlug.thumbnailtype}",
-	'type' => "string",
-	'deft' => "jpeg",
-	'reqd' => "no" },
-      { 'name' => "extractscreenview",
-	'desc' => "{VideoPlug.extractscreenview}",
-	'type' => "flag",
-	'deft' => "0",
-	'reqd' => "no" },
-      { 'name' => "screenviewsize",
-	'desc' => "{VideoPlug.screenviewsize}",
-	'type' => "int",
-	'deft' => "0",
-	'range' => "1,",
-	'reqd' => "no" },
-      { 'name' => "screenviewtype",
-	'desc' => "{VideoPlug.screenviewtype}",
-	'type' => "string",
-	'deft' => "jpg",
-	'reqd' => "no" },
-      { 'name' => "converttotype",
-	'desc' => "{VideoPlug.converttotype}",
-	'type' => "string",
-	'deft' => "",
-	'reqd' => "no" },
-      { 'name' => "converttosize",
-	'desc' => "{VideoPlug.converttosize}",
-	'type' => "int",
-	'deft' => "",
-##	'deft' => "352",
-	'reqd' => "no" },
-      { 'name' => "converttobitrate",
-	'desc' => "{VideoPlug.converttobitrate}",
-	'type' => "string",
-	'deft' => "200k",
-	'reqd' => "no" },
-      { 'name' => "extractkeyframes",
-	'desc' => "{VideoPlug.extractkeyframes}",
-	'type' => "flag",
-	'deft' => "0",
-	'reqd' => "no" },
-      { 'name' => "enablestreaming",
-	'desc' => "{VideoPlug.enablestreaming}",
-	'type' => "flag",
-	'deft' => "1",
-	'reqd' => "no" },
-      { 'name' => "streamingsize",
-	'desc' => "{VideoPlug.streamingsize}",
-	'type' => "int",
-	'deft' => "352",
-	'reqd' => "no" },
-      { 'name' => "streamingbitrate",
-	'desc' => "{VideoPlug.streamingbitrate}",
-	'type' => "string",
-	'deft' => "200k",
-	'reqd' => "no" },
-      { 'name' => "minimumsize",
-	'desc' => "{VideoPlug.minimumsize}",
-	'type' => "int",
-	'deft' => "100",
-	'range' => "1,",
 	'reqd' => "no" } ];
 
+
 my $options = { 'name'     => "VideoPlugin",
-		'desc'     => "{VideoPlug.desc}",
+		'desc'     => "{VideoPlugin.desc}",
 		'abstract' => "no",
 		'inherits' => "yes",
 		'args'     => $arguments };
-
-
-my ($self);
 
 sub new {
@@ -181,46 +66,25 @@
     push(@{$hashArgOptLists->{"OptList"}},$options);
 
-    $self = new BasePlugin($pluginlist, $inputargs, $hashArgOptLists);
-
-    # Check that ffmpeg is installed and available on the path (except for Windows 95/98)
-    # This test is "inherited" from ImagePlugin where ImageMagick support
-    # for building cannot be used on these two versions of Windows as they
-    # do not have enough flexablity in the use of stdout and stderr to
-    # support how our code works.  It seems reasonable to assume the
-    # same is true for VideoPlugin work using ffmpeg.
-
-    if (($ENV{'GSDLOS'} ne "windows" || Win32::IsWinNT())) {
-
-	my $result = `ffmpeg -h 2>&1`;
-
-
-	if (!defined $result || $result !~ m/^FFmpeg version/) {
-	    $self->{'ffmpeg_installed'} = 0;
-	    print STDERR $result;
-	}
-	else {
-	    $self->{'ffmpeg_installed'} = 1;
-	}
-
-    }
-
-
-    # create XML::Parser object for parsing metadata.xml files
-    my $parser;
-    if ($]<5.008) {
-	# Perl 5.6
-	$parser = new XML::Parser('Style' => 'Stream',
-				  'Handlers' => {'Char' => \&Char,
-						 'Doctype' => \&Doctype
-						 });
-    }
-    else {
-	# Perl 5.8
-	$parser = new XML::Parser('Style' => 'Stream',
-				  'ProtocolEncoding' => 'ISO-8859-1',
-				  'Handlers' => {'Char' => \&Char,
-						 'Doctype' => \&Doctype
-						 });
-    }
+    new VideoConverter($pluginlist, $inputargs, $hashArgOptLists);
+    my $self = new MultimediaPlugin($pluginlist, $inputargs, $hashArgOptLists);
+
+    if ($self->{'info_only'}) {
+	# don't worry about creating the XML parser as all we want is the 
+	# list of plugin options
+	return bless $self, $class;
+    }
+
+
+    # create XML::Parser object for parsing keyframe files (produced by hive)
+    my $parser = new XML::Parser('Style' => 'Stream',
+                                 'Pkg' => 'VideoPlugin',
+                                 'PluginObj' => $self,
+				 'Namespaces' => 1, # strip out namespaces
+				 'Handlers' => {'Char' => \&Char,
+						'XMLDecl' => \&XMLDecl,
+						'Entity'  => \&Entity,
+						'Doctype' => \&Doctype,
+						'Default' => \&Default
+                                 });
 
     $self->{'parser'} = $parser;
@@ -228,4 +92,14 @@
 
     return bless $self, $class;
+}
+
+
+
+sub begin {
+    my $self = shift (@_);
+    my ($pluginfo, $base_dir, $processor, $maxdocs) = @_;
+
+    $self->SUPER::begin(@_);
+    $self->VideoConverter::begin(@_); 
 }
 
@@ -236,5 +110,5 @@
 
     $self->SUPER::init(@_);
-    ## $self->ImageConverter::init(); # ****** VideoConverter::init ??
+    $self->VideoConverter::init(@_);
 }
 
@@ -246,14 +120,271 @@
 }
 
-# this makes no sense for image
-sub block_cover_image
+
+sub extract_keyframes
 {
-    my $self =shift (@_);
-    my ($filename) = @_;
-
-    return;
-}
-
-
+    my $self = shift (@_);
+    my ($doc_obj,$originalfilename,$filename) = @_;
+
+    my $section = $doc_obj->get_top_section();
+
+    my $output_dir   = $self->{'cached_dir'};
+    my $ivideo_root  = $self->{'cached_file_root'};
+
+    # Generate the keyframes with ffmpeg and hive
+    my ($keyframe_cmd,$okeyframe_filename) = $self->keyframe_cmd($originalfilename || $filename);
+    
+    my $keyframe_options = { @{$self->{'ffmpeg_monitor'}},
+			     'message_prefix' => "Keyframe",
+			     'message' => "Extracting keyframes" }; 
+    
+    $self->autorun_cached_general_cmd($keyframe_cmd,$okeyframe_filename,$keyframe_options);
+    $self->parse_shot_xml();
+    $self->associate_keyframes($doc_obj,$section);
+}
+
+
+sub enable_streaming
+{
+    my $self = shift (@_);
+    my ($doc_obj,$originalfilename,$filename,$convertto_regenerated,
+	$video_width,$video_height) = @_;
+
+    my $section = $doc_obj->get_top_section();
+
+    my $output_dir   = $self->{'cached_dir'};
+    my $ivideo_root  = $self->{'cached_file_root'};
+    
+    # Generate the Flash FLV format for streaming purposes
+    my $streamable_regenerated = 0;
+
+    my $optionally_run_general_cmd = "run_uncached_general_cmd";
+    if ($self->{'enable_cache'}) {
+	$optionally_run_general_cmd
+	    = ($convertto_regenerated) ? "regenerate_general_cmd" : "run_cached_general_cmd";
+    }
+
+    my $streaming_bitrate = $self->{'streamingbitrate'};
+    my $streaming_size    = $self->{'streamingsize'};
+    
+    my $streaming_quality = "high";
+    
+    my ($stream_cmd,$oflash_filename,$oflash_file) 
+	= $self->stream_cmd($originalfilename || $filename,
+			    $video_width,$video_height,
+			    $streaming_quality,
+			    $streaming_bitrate, $streaming_size);
+    
+    
+    my $streamable_options = { @{$self->{'ffmpeg_monitor'}},
+			       'message_prefix' => "Stream",
+			       'message' => "Generating streamable video: $oflash_file" }; 
+    
+    my $streamable_result;
+    my $streamable_had_error;
+    ($streamable_regenerated,$streamable_result,$streamable_had_error)
+	= $self->$optionally_run_general_cmd($stream_cmd,$oflash_filename,$streamable_options);
+    
+    if (!$streamable_had_error) {
+	my ($streamseekable_cmd,$ostreamseekable_filename) = $self->streamseekable_cmd($oflash_filename);
+	
+	my $streamseekable_options = { @{$self->{'flvtool2_monitor'}},
+				       'message_prefix' => "Stream Seekable",
+				       'message' => "Reprocessing video stream to be seekable by timeline: $oflash_file" }; 
+	
+	if ($streamable_regenerated) {
+	    $self->run_general_cmd($streamseekable_cmd,$streamseekable_options);
+	}
+	
+	my $streamable_url = $oflash_file;
+	## $streamable_url =~ s/ /%20/g;
+	my $streamable_url_safe = $self->url_safe($streamable_url);
+	
+	$doc_obj->add_utf8_metadata ($section, "streamablevideo", $streamable_url_safe);
+	$doc_obj->associate_file($oflash_filename,$oflash_file,"video/flash",
+				 $section);
+    }
+
+##    my $video_width = $doc_obj->get_metadata_element($section,"VideoWidth");
+##    my $video_height = $doc_obj->get_metadata_element($section,"VideoHeight");
+    
+    #
+    # FlowPlayer.swf       height+22 pixels
+    # FlowPlayerBlack.swf  height+16 pixels
+    # FlowPlayerThermo.swf height+16 pixels
+    # FlowPlayerWhite.swf  height+26 pixels
+    my $flashwidth = $video_width;
+    my $flashheight = $video_height + 22;
+    if ($self->{'extractkeyframes'}) {
+	$flashheight += 100;
+    }
+    $doc_obj->add_metadata ($section, "flashwidth",    $flashwidth);
+    $doc_obj->add_metadata ($section, "flashheight",   $flashheight);
+    
+    my $video_server = $ENV{'GEXT_VIDEO_SERVER'};
+    my $video_prefix = $ENV{'GEXT_VIDEO_PREFIX'};
+    my $base_url = "$video_server$video_prefix/collect/[collection]/index/assoc/[assocfilepath]/";
+    my $base_url_safe = $self->url_safe($base_url);
+    $doc_obj->add_utf8_metadata ($section, "baseurl",$base_url_safe);
+    
+    $self->{'oflash_file'} = $oflash_file;
+    $self->{'oflash_filename'} = $oflash_filename;
+
+    return $streamable_regenerated;
+}
+
+sub extract_thumbnail
+{
+    my $self = shift (@_);
+    my ($doc_obj,$filename,$convertto_regenerated,$thumbnailtype,
+	$thumbnail_width, $thumbnail_height) = @_;
+
+    my $section = $doc_obj->get_top_section();
+
+    my $output_dir   = $self->{'cached_dir'};
+    my $ivideo_root  = $self->{'cached_file_root'};
+
+    my $verbosity = $self->{'verbosity'};
+    my $outhandle = $self->{'outhandle'};
+
+
+    # Generate the thumbnail with convert, a la ImagePlug
+
+    my $thumbnailfile = &util::filename_cat($output_dir,"$ivideo_root.$thumbnailtype");
+    
+    
+    my $optionally_run_general_cmd = "run_uncached_general_cmd";
+    if ($self->{'enable_cache'}) {	
+	$optionally_run_general_cmd 
+	= ($convertto_regenerated) ? "regenerate_general_cmd" : "run_cached_general_cmd";
+    }
+    
+    my ($thumb_cmd ,$othumb_filename)
+	= $self->keyframe_thumbnail_cmd($filename,$thumbnailfile,$thumbnail_width,$thumbnail_height);
+    
+    my $thumb_options = { 'verbosity' => $verbosity,
+			  'outhandle' => $outhandle,
+			  'message_prefix' => "Thumbnail",
+			  'message' => "Generating thumbnail" }; 
+    
+    my ($thumb_regenerated,$thumb_result,$thumb_had_error)
+	= $self->$optionally_run_general_cmd($thumb_cmd,$thumbnailfile,$thumb_options);
+    
+    # Add the thumbnail as an associated file ...
+    if (-e "$thumbnailfile") { 
+	$doc_obj->associate_file("$thumbnailfile", "thumbnail.$thumbnailtype", 
+				 "image/$thumbnailtype",$section);
+	$doc_obj->add_metadata ($section, "ThumbType", $thumbnailtype);
+	$doc_obj->add_metadata ($section, "Thumb", "thumbnail.$thumbnailtype");
+	
+	$doc_obj->add_utf8_metadata ($section, "thumbicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[Thumb]\" width=[ThumbWidth] height=[ThumbHeight]>");
+###	    $doc_obj->add_utf8_metadata ($section, "thumbicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[Thumb]\">");
+    }
+    
+    # Extract Thumnail metadata from convert output
+    if ($thumb_result =~ m/[0-9]+x[0-9]+=>([0-9]+)x([0-9]+)/) {
+	$doc_obj->add_metadata ($section, "ThumbWidth", $1);
+	$doc_obj->add_metadata ($section, "ThumbHeight", $2);
+    }
+    else {
+	# Two reasons for getting to here:
+	#   1.thumbnail was generated by ffmpeg, not imagemagick convert
+	#   2.thumbnail was cached, so imagemagick convert was not run
+	# Either way, the solution is the same:
+	# => run "identify $thumbnailfile" and parse result
+	
+	$thumb_result = `identify \"$thumbnailfile\"`;
+	
+	if ($thumb_result =~ m/([0-9]+)x([0-9]+)/) {
+	    $doc_obj->add_metadata ($section, "ThumbWidth", $1);
+	    $doc_obj->add_metadata ($section, "ThumbHeight", $2);
+	}
+    }
+}
+
+
+sub extract_keyframes_montage
+{
+    my $self = shift (@_);
+    my ($doc_obj,$filename,$thumbnailtype) = @_;
+
+    my $section = $doc_obj->get_top_section();
+
+    my $output_dir   = $self->{'cached_dir'};
+    my $ivideo_root  = $self->{'cached_file_root'};
+
+    
+    # Generate the mosaic with 'montage'
+    my $montagefile = &util::filename_cat($output_dir,"$ivideo_root\_montage.$thumbnailtype");
+    
+    my ($montage_cmd,$omontage_filename)
+	= $self->keyframe_montage_cmd($filename,$montagefile);
+    
+    my $montage_options = { 'message_prefix' => "Montage",
+			    'message' => "Generating montage" }; 
+    
+    my ($montage_result,$montage_had_error)
+	= $self->run_general_cmd($montage_cmd,$montage_options);
+    
+    # Add the montage as an associated file ...
+    if (-e "$montagefile") { 
+	$doc_obj->associate_file("$montagefile", "montage.$thumbnailtype", 
+				 "image/$thumbnailtype",$section);
+	$doc_obj->add_metadata ($section, "MontageType", $thumbnailtype);
+	$doc_obj->add_metadata ($section, "Montage", "montage.$thumbnailtype");
+	
+	$doc_obj->add_utf8_metadata ($section, "montageicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[Montage]\" >");
+    }
+}
+
+
+
+sub extract_screenview
+{
+    my $self = shift (@_);
+    my ($doc_obj,$filename,$screenviewtype, $screenview_width,$screenview_height) = @_;
+
+    my $section = $doc_obj->get_top_section();
+
+    my $output_dir   = $self->{'cached_dir'};
+    my $ivideo_root  = $self->{'cached_file_root'};
+    
+    
+    # make the screenview image
+
+    my $screenviewfilename = &util::filename_cat($output_dir,"$ivideo_root.$screenviewtype");
+
+    
+    my ($screenview_cmd,$oscreenview_filename)
+	= $self->keyframe_thumbnail_cmd($filename,$screenviewfilename,$screenview_width,$screenview_height);
+
+    my $screenview_options = { 'message_prefix' => "Screenview",
+			       'message' => "Generating screenview image" }; 
+
+    my ($result,$had_error)
+	= $self->run_general_cmd($screenview_cmd,$screenview_options);
+
+    # get screenview dimensions, size and type
+    if ($result =~ m/[0-9]+x[0-9]+=>([0-9]+)x([0-9]+)/) {
+	$doc_obj->add_metadata ($section, "ScreenWidth", $1);
+	$doc_obj->add_metadata ($section, "ScreenHeight", $2);
+    }
+    else {
+	$doc_obj->add_metadata ($section, "ScreenWidth", $screenview_width);
+	$doc_obj->add_metadata ($section, "ScreenHeight", $screenview_height);
+    }
+    
+    #add the screenview as an associated file ...
+    if (-e "$screenviewfilename") { 
+	$doc_obj->associate_file("$screenviewfilename", "screenview.$screenviewtype",
+				 "image/$screenviewtype",$section);
+	$doc_obj->add_metadata ($section, "ScreenType", $screenviewtype);
+	$doc_obj->add_metadata ($section, "Screen", "screenview.$screenviewtype");
+	
+	$doc_obj->add_utf8_metadata ($section, "screenicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[Screen]\" width=[ScreenWidth] height=[ScreenHeight]>");
+    } else {
+	my $outhandle = $self->{'outhandle'};
+	print $outhandle "VideoPlugin: couldn't find \"$screenviewfilename\"\n";
+    }
+}
 
 
@@ -284,5 +415,5 @@
     my ($video_type, $video_width, $video_height, $video_duration, $video_size,
 	$vcodec,$vfps,$atype,$afreq,$achan,$arate) 
-	= &videoconvert::identify($filename, $outhandle, $verbosity);
+	= &VideoConverter::identify($filename, $outhandle, $verbosity);
 
     if ($vfps eq "unknown") {
@@ -305,8 +436,8 @@
     my $exp_duration = undef;
     
-    my $video_excerpt_duration = $self->{'video_excerpt_duration'};
-
-    if ((defined $video_excerpt_duration) && ($video_excerpt_duration ne "")) {
-	$exp_duration = $video_excerpt_duration;
+    my $excerpt_duration = $self->{'excerpt_duration'};
+
+    if ((defined $excerpt_duration) && ($excerpt_duration ne "")) {
+	$exp_duration = $excerpt_duration;
 	my ($hh,$mm,$ss,$ms) = ($exp_duration =~ m/^(\d\d):(\d\d):(\d\d)\.?(\d\d)?/);
 	my $excerpt_dur_in_secs = $hh * 3600 + $mm * 60 + $ss;
@@ -330,13 +461,11 @@
 
     my $ascii_only_filenames = $self->{'use_ascii_only_filenames'};
-    my $videoconvert 
-	= new videoconvert($base_dir,$filename,$verbosity,$outhandle,$exp_duration,$ascii_only_filenames);
-    $self->{'videoconvert'} = $videoconvert;
+    $self->init_cache_for_file($filename);
 
     my $originalfilename = undef;
     my $type = "unknown";
 
-    my $output_dir = $videoconvert->{'cached_dir'};
-    my $ivideo_root = $videoconvert->{'file_root'};
+    my $output_dir = $self->{'cached_dir'};
+    my $ivideo_root = $self->{'cached_file_root'};
 
     my $convertto_regenerated = 0;
@@ -355,5 +484,5 @@
 	$filename = &util::filename_cat($output_dir,$file);
  
-	my $s_opt = $videoconvert->optional_frame_scale($converttosize,$video_width,$video_height);
+	my $s_opt = $self->optional_frame_scale($converttosize,$video_width,$video_height);
 	my $exp_duration = $self->{'exp_duration'};
 	my $t_opt = (defined $exp_duration) ? "-t $exp_duration" : "";
@@ -373,10 +502,10 @@
 	my $convertto_error;
 	
-	my $convertto_options = { @{$videoconvert->{'ffmpeg_monitor'}},
+	my $convertto_options = { @{$self->{'ffmpeg_monitor'}},
 				  'message_prefix' => "Convert to",
 				  'message' => "Converting video to $converttotype" }; 
 
 	($convertto_regenerated,$convertto_result,$convertto_error)
-	    = $videoconvert->run_cached_general_cmd($convertto_command,$filename,$convertto_options);
+	    = $self->autorun_cached_general_cmd($convertto_command,$filename,$convertto_options);
 						    
 	$type = $converttotype;
@@ -414,5 +543,5 @@
     $file = $file_unicode;
     my $filemeta = $self->filename_to_utf8_metadata($file);
-    my $filemeta_url_safe = $videoconvert->url_safe($filemeta);
+    my $filemeta_url_safe = $self->url_safe($filemeta);
 
     $doc_obj->add_utf8_metadata ($section, "Video", $filemeta_url_safe);
@@ -454,241 +583,75 @@
 
     if ($self->{'extractkeyframes'}) {
-	# Generate the keyframes with ffmpeg and hive
-	my ($keyframe_cmd,$okeyframe_filename) = $videoconvert->keyframe_cmd($originalfilename || $filename);
-
-	my $keyframe_options = { @{$videoconvert->{'ffmpeg_monitor'}},
-				 'message_prefix' => "Keyframe",
-				 'message' => "Extracting keyframes" }; 
-
-	$videoconvert->run_cached_general_cmd($keyframe_cmd,$okeyframe_filename,$keyframe_options);
-	$videoconvert->parse_shot_xml($self);
-	$videoconvert->associate_keyframes($doc_obj,$section,$self);
+	$self->extract_keyframes($doc_obj,$originalfilename,$filename);
     }
 
     my $streamable_regenerated = 0;
-    my $optionally_run_general_cmd 
-	= ($convertto_regenerated) ? "regenerate_general_cmd" : "run_cached_general_cmd";
-
-    if ($self->{'enablestreaming'}) {
-	# Generate the Flash FLV format for streaming purposes
-
-	my $streaming_bitrate = $self->{'streamingbitrate'};
-	my $streaming_size    = $self->{'streamingsize'};
-
-	my $streaming_quality = "high";
-
-	my ($stream_cmd,$oflash_filename,$oflash_file) 
-	    = $videoconvert->stream_cmd($originalfilename || $filename,
-					$video_width,$video_height,
-					$streaming_quality,
-					$streaming_bitrate, $streaming_size);
-
-
-	my $streamable_options = { @{$videoconvert->{'ffmpeg_monitor'}},
-				   'message_prefix' => "Stream",
-				   'message' => "Generating streamable video: $oflash_file" }; 
-
-	my $streamable_result;
-	my $streamable_had_error;
-	($streamable_regenerated,$streamable_result,$streamable_had_error)
-	    = $videoconvert->$optionally_run_general_cmd($stream_cmd,$oflash_filename,$streamable_options);
-
-	if (!$streamable_had_error) {
-	    my ($streamseekable_cmd,$ostreamseekable_filename) = $videoconvert->streamseekable_cmd($oflash_filename);
-
-	    my $streamseekable_options = { @{$videoconvert->{'flvtool2_monitor'}},
-					   'message_prefix' => "Stream Seekable",
-					   'message' => "Reprocessing video stream to be seekable by timeline: $oflash_file" }; 
-
-	    if ($streamable_regenerated) {
-		$videoconvert->run_general_cmd($streamseekable_cmd,$streamseekable_options);
-	    }
-
-	    my $streamable_url = $oflash_file;
-	    ## $streamable_url =~ s/ /%20/g;
-	    my $streamable_url_safe = $videoconvert->url_safe($streamable_url);
-
-	    $doc_obj->add_utf8_metadata ($section, "streamablevideo", $streamable_url_safe);
-	    $doc_obj->associate_file($oflash_filename,$oflash_file,"video/flash",
-				     $section);
-	}
-
-	my $video_width = $doc_obj->get_metadata_element($section,"VideoWidth");
-	my $video_height = $doc_obj->get_metadata_element($section,"VideoHeight");
-	
-	#
-	# FlowPlayer.swf       height+22 pixels
-	# FlowPlayerBlack.swf  height+16 pixels
-	# FlowPlayerThermo.swf height+16 pixels
-	# FlowPlayerWhite.swf  height+26 pixels
-	my $flashwidth = $video_width;
-	my $flashheight = $video_height + 22;
-	if ($self->{'extractkeyframes'}) {
-	    $flashheight += 100;
-	}
-	$doc_obj->add_metadata ($section, "flashwidth",    $flashwidth);
-	$doc_obj->add_metadata ($section, "flashheight",   $flashheight);
-	
-	my $video_server = $ENV{'GEXT_VIDEO_SERVER'};
-	my $video_prefix = $ENV{'GEXT_VIDEO_PREFIX'};
-	my $base_url = "$video_server$video_prefix/collect/[collection]/index/assoc/[assocfilepath]/";
-	my $base_url_safe = $videoconvert->url_safe($base_url);
-	$doc_obj->add_utf8_metadata ($section, "baseurl",$base_url_safe);
-	
-	$self->{'oflash_file'} = $oflash_file;
-	$self->{'oflash_filename'} = $oflash_filename;
-    }
-
-
-    # Make the thumbnail image
+
+    if ($self->{'enable_streaming'}) {	
+	$streamable_regenerated 
+	    = $self->enable_streaming($doc_obj,$originalfilename,$filename,
+				      $convertto_regenerated,
+				      $video_width,$video_height);
+    }
+
+
     my $thumbnailsize = $self->{'thumbnailsize'} || 100;
     my $thumbnailtype = $self->{'thumbnailtype'} || 'jpg';
 
-    my $thumbnailwidth; 
-    my $thumbnailheight;
-
-    if ($video_width>$video_height) {
-	my $scale_ratio = $video_height / $video_width;
-	$thumbnailwidth = $thumbnailsize;
-	$thumbnailheight = int($thumbnailsize * $scale_ratio);
-    }
-    else {
-	my $scale_ratio = $video_width / $video_height;
-	$thumbnailwidth = int($thumbnailsize * $scale_ratio);
-	$thumbnailheight = $thumbnailsize;
-    }
-
-
-    my $thumbnailfile = &util::filename_cat($output_dir,"$ivideo_root.$thumbnailtype");
-
-
-    if ($self->{'extractthumbnail'}) {
-	# Generate the thumbnail with convert, a la ImagePlug
-	my ($thumb_cmd ,$othumb_filename)
-	    = $videoconvert->keyframe_thumbnail_cmd($filename,$thumbnailfile,$thumbnailwidth,$thumbnailheight);
-
-	my $thumb_options = { 'verbosity' => $verbosity,
-			      'outhandle' => $outhandle,
-			      'message_prefix' => "Thumbnail",
-			      'message' => "Generating thumbnail" }; 
-
-	my ($thumb_regenerated,$thumb_result,$thumb_had_error)
-	    = $videoconvert->$optionally_run_general_cmd($thumb_cmd,$thumbnailfile,$thumb_options);
-
-	# Add the thumbnail as an associated file ...
-	if (-e "$thumbnailfile") { 
-	    $doc_obj->associate_file("$thumbnailfile", "thumbnail.$thumbnailtype", 
-				     "image/$thumbnailtype",$section);
-	    $doc_obj->add_metadata ($section, "ThumbType", $thumbnailtype);
-	    $doc_obj->add_metadata ($section, "Thumb", "thumbnail.$thumbnailtype");
-
-	    $doc_obj->add_utf8_metadata ($section, "thumbicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[Thumb]\" width=[ThumbWidth] height=[ThumbHeight]>");
-###	    $doc_obj->add_utf8_metadata ($section, "thumbicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[Thumb]\">");
-	}
-
-	# Extract Thumnail metadata from convert output
-	if ($thumb_result =~ m/[0-9]+x[0-9]+=>([0-9]+)x([0-9]+)/) {
-	    $doc_obj->add_metadata ($section, "ThumbWidth", $1);
-	    $doc_obj->add_metadata ($section, "ThumbHeight", $2);
+
+    if ($self->{'create_thumbnail'} eq "true") {
+
+	my $thumbnail_width; 
+	my $thumbnail_height;
+	
+	if ($video_width>$video_height) {
+	    my $scale_ratio = $video_height / $video_width;
+	    $thumbnail_width = $thumbnailsize;
+	    $thumbnail_height = int($thumbnailsize * $scale_ratio);
 	}
 	else {
-	    # Two reasons for getting to here:
-	    #   1.thumbnail was generated by ffmpeg, not imagemagick convert
-	    #   2.thumbnail was cached, so imagemagick convert was not run
-	    # Either way, the solution is the same:
-	    # => run "identify $thumbnailfile" and parse result
-
-	    $thumb_result = `identify \"$thumbnailfile\"`;
-	    
-	    if ($thumb_result =~ m/([0-9]+)x([0-9]+)/) {
-		$doc_obj->add_metadata ($section, "ThumbWidth", $1);
-		$doc_obj->add_metadata ($section, "ThumbHeight", $2);
-	    }
-	}
+	    my $scale_ratio = $video_width / $video_height;
+	    $thumbnail_width = int($thumbnailsize * $scale_ratio);
+	    $thumbnail_height = $thumbnailsize;
+	}
+	
+
+	$self->extract_thumbnail($doc_obj,$filename,$convertto_regenerated,
+				 $thumbnailtype, 
+				 $thumbnail_width,$thumbnail_height);
     }
 
 
     if ($self->{'extractkeyframes'}) {
-
-	# Generate the mosaic with 'montage'
-	my $montagefile = &util::filename_cat($output_dir,"$ivideo_root\_montage.$thumbnailtype");
-
-	my ($montage_cmd,$omontage_filename)
-	    = $videoconvert->keyframe_montage_cmd($filename,$montagefile);
-
-	my $montage_options = { 'message_prefix' => "Montage",
-				'message' => "Generating montage" }; 
-
-	my ($montage_result,$montage_had_error)
-	    = $videoconvert->run_general_cmd($montage_cmd,$montage_options);
-
-	# Add the montage as an associated file ...
-	if (-e "$montagefile") { 
-	    $doc_obj->associate_file("$montagefile", "montage.$thumbnailtype", 
-				     "image/$thumbnailtype",$section);
-	    $doc_obj->add_metadata ($section, "MontageType", $thumbnailtype);
-	    $doc_obj->add_metadata ($section, "Montage", "montage.$thumbnailtype");
-
-	    $doc_obj->add_utf8_metadata ($section, "montageicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[Montage]\" >");
-	}
-    }
+	$self->extract_keyframes_montage($doc_obj,$filename,$thumbnailtype);
+    }
+
+    my $screenviewsize = $self->{'screenviewsize'};
+    my $screenviewtype = $self->{'screenviewtype'} || 'jpeg';
 
     # Make a screen-sized version of the picture if requested
-    if ($self->{'extractscreenview'}) {
+    if ($self->{'create_screenview'} eq "true") {
 
 	# To do: if the actual image smaller than the screenview size,
 	# we should use the original !
 
-	my $screenviewsize = $self->{'screenviewsize'};
-	my $screenviewtype = $self->{'screenviewtype'} || 'jpeg';
-	my $screenviewfilename = &util::filename_cat($output_dir,"$ivideo_root.$screenviewtype");
-
-	my $screenviewwidth; 
-	my $screenviewheight;
+	my $screenview_width; 
+	my $screenview_height;
 	
 	if ($video_width>$video_height) {
 	    my $scale_ratio = $video_height / $video_width;
-	    $screenviewwidth = $screenviewsize;
-	    $screenviewheight = int($screenviewsize * $scale_ratio);
+	    $screenview_width = $screenviewsize;
+	    $screenview_height = int($screenviewsize * $scale_ratio);
 	}
 	else {
 	    my $scale_ratio = $video_width / $video_height;
-	    $screenviewwidth = int($screenviewsize * $scale_ratio);
-	    $screenviewheight = $screenviewsize;
-	}
-
-
-	# make the screenview image
-
-	my ($screenview_cmd,$oscreenview_filename)
-	    = $videoconvert->keyframe_thumbnail_cmd($filename,$screenviewfilename,$screenviewwidth,$screenviewheight);
-
-	my $screenview_options = { 'message_prefix' => "Screenview",
-				   'message' => "Generating screenview image" }; 
-
-	my ($result,$had_error)
-	    = $videoconvert->run_general_cmd($screenview_cmd,$screenview_options);
-
-	# get screenview dimensions, size and type
-        if ($result =~ m/[0-9]+x[0-9]+=>([0-9]+)x([0-9]+)/) {
-	    $doc_obj->add_metadata ($section, "ScreenWidth", $1);
-	    $doc_obj->add_metadata ($section, "ScreenHeight", $2);
-	}
-	else {
-	    $doc_obj->add_metadata ($section, "ScreenWidth", $video_width);
-	    $doc_obj->add_metadata ($section, "ScreenHeight", $video_height);
-	}
-
-	#add the screenview as an associated file ...
-	if (-e "$screenviewfilename") { 
-	    $doc_obj->associate_file("$screenviewfilename", "screenview.$screenviewtype",
-				     "image/$screenviewtype",$section);
-	    $doc_obj->add_metadata ($section, "ScreenType", $screenviewtype);
-	    $doc_obj->add_metadata ($section, "Screen", "screenview.$screenviewtype");
-
-	    $doc_obj->add_utf8_metadata ($section, "screenicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[Screen]\" width=[ScreenWidth] height=[ScreenHeight]>");
-	} else {
-	    print $outhandle "VideoPlugin: couldn't find \"$screenviewfilename\"\n";
-	}
+	    $screenview_width = int($screenviewsize * $scale_ratio);
+	    $screenview_height = $screenviewsize;
+	}
+
+
+	$self->extract_screenview($doc_obj,$filename,
+				  $screenviewtype,
+				  $screenview_width,$screenview_height);
     }
 
